{-# LANGUAGE DataKinds #-}

module StressTensors3d.Programs.TSigEps2023Data where

import Bootstrap.Math.AffineTransform     (AffineTransform (..))
import Bootstrap.Math.Linear              (Matrix, toM, toV)
import Linear.V                           (V)

opeEllipseGuessNmax6 :: Matrix 5 5 Rational
opeEllipseGuessNmax6 = toM
  ( (50, 0, -48.136922, 0, 0)
  , (0, 10204.082, -147.3589, 0, 0)
  , (-48.136922, -147.3589, 162.7941, -72.844493, -11.289593)
  , (0, 0, -72.844493, 50, 0)
  , (0, 0, -11.289593, 0, 12.5)
  )

opeEllipseGuessNmax6' :: Matrix 5 5 Rational
opeEllipseGuessNmax6' = toM
  ( (50,0,-48.136922,0,0)
  , (0,8,-0.11552937,0,0)
  , (-48.136922,-0.11552937,150.73237,-72.844493,-0.28901358)
  , (0,0,-72.844493,50,0)
  , (0,0,-0.28901358,0,0.32)
  )

-- | This is the OPE ellipse extracted from an island computed with the above,
--  more conservative ellipse. It represents the bounding ellipse 10x bigger
-- than the space of feasible OPE vectors for all of the island's primal points.
opeEllipseEvenTNmax6 :: Matrix 5 5 Rational
opeEllipseEvenTNmax6 = toM
  ( (0.359816, 0.377074, -0.277216, 0.0022255, -0.0858743)
  , (0.377074, 0.423357, -0.287684, 0.00293715, -0.0945149)
  , (-0.277216, -0.287684, 0.214176, -0.00194404, 0.065825)
  , (0.0022255, 0.00293715, -0.00194404, 0.00086518, -0.00165357)
  , (-0.0858743, -0.0945149, 0.065825, -0.00165357, 0.0227361)
  )

-- | OPE ellipse extracted from the island computed in
-- 'TSigEps_OPEScan_island_nmax10_higher_spin' with 12 allowed points,
-- expanded by a factor of 4x around the allowed points.
opeEllipseNmax10 :: Matrix 5 5 Rational
opeEllipseNmax10 = toM
  ( (0.369573668341191, 0.384617653959426, -0.276544605701002, -0.00381206327506594, -0.0874368843527168)
  , (0.384617653959426, 0.405419312783056, -0.287691690018541, -0.00252415075121507, -0.0935140117523496)
  , (-0.276544605701002, -0.287691690018541, 0.206938867047613, 0.00287012593685447, 0.0653906081025902)
  , (-0.00381206327506594, -0.00252415075121507, 0.00287012593685447, 0.000525840586792641, 0.000078833728129841)
  , (-0.0874368843527168, -0.0935140117523496, 0.0653906081025902, 0.000078833728129841, 0.0220876295833331)
  )

-- | This is the affine transform extracted in the same way as the above.
isingAffineNmax6 :: AffineTransform 2 Rational
isingAffineNmax6 =  AffineTransform
  { affineShift  = toV (0.518171,1.41269)
  , affineLinear = toV ( toV (0.000305562, 0.00349606), toV (-0.0000734378, 6.4186e-6))
  }

allowedPointsNmax14 :: [(V 2 Rational, V 5 Rational)]
allowedPointsNmax14 =
  [ ( toV (0.5181488170, 1.412625285)
    , toV ( -46545797/106621260
          , -30573457/4992567563
          , -41243863/91043379
          , -141648593/214621132
          , -48246023/117508537
          )
    )
  ]

-- A circle of points roughly surrounding the nmax=6 island
initialDisallowedPtsNmax10 :: [V 2 Rational]
initialDisallowedPtsNmax10 = toV <$>
  [ (0.5179356195, 1.410060572), (0.5179423358, 1.410256666)
  , (0.5179835819, 1.410813079), (0.5180530785, 1.411645101)
  , (0.5181402453, 1.412626066), (0.5182318120, 1.413606630)
  , (0.5183138384, 1.414437511), (0.5183738366, 1.414992215)
  , (0.5184026726, 1.415186293), (0.5183959563, 1.414990199)
  , (0.5183547102, 1.414433787), (0.5182852136, 1.413601764)
  , (0.5181980468, 1.412620799), (0.5181064801, 1.411640235)
  , (0.5180244537, 1.410809354), (0.5179644555, 1.410254650)
  , (0.5179356195, 1.410060572)
  ]

initialNmax6DisallowedPts :: [V 2 Rational]
initialNmax6DisallowedPts = toV <$> [(2053/4000, 1079/800), (64/125, 269/200), (2053/4000, 1083/800), (64/125, 67/50), (64/125, 34/25), (64/125, 27/20), (64/125, 271/200), (2053/4000, 1087/800), (64/125, 273/200), (2053/4000, 1091/800), (64/125, 137/100), (2053/4000, 219/160), (2053/4000, 1103/800), (2053/4000, 1099/800), (64/125, 11/8), (64/125, 69/50), (2053/4000, 1107/800), (2053/4000, 1111/800), (1029/2000, 543/400), (1029/2000, 109/80), (1029/2000, 547/400), (1029/2000, 549/400), (1029/2000, 551/400), (1029/2000, 553/400), (1029/2000, 557/400), (1029/2000, 111/80), (1029/2000, 559/400), (2063/4000, 1093/800), (2063/4000, 1097/800), (2063/4000, 1101/800), (2063/4000, 221/160), (2063/4000, 1113/800), (2063/4000, 1109/800), (2063/4000, 1117/800), (2063/4000, 1121/800), (517/1000, 11/8), (2063/4000, 45/32), (517/1000, 69/50), (517/1000, 277/200), (517/1000, 279/200), (517/1000, 7/5), (517/1000, 141/100), (517/1000, 281/200), (517/1000, 283/200), (2073/4000, 1111/800), (2073/4000, 223/160), (2073/4000, 1107/800), (2073/4000, 1119/800), (2073/4000, 1123/800), (2073/4000, 1127/800), (2073/4000, 1131/800), (2073/4000, 227/160), (1039/2000, 557/400), (2073/4000, 1139/800), (1039/2000, 559/400), (1039/2000, 561/400), (1039/2000, 563/400), (1039/2000, 113/80), (1039/2000, 569/400), (1039/2000, 567/400), (1039/2000, 571/400), (1039/2000, 573/400), (2083/4000, 1121/800), (2083/4000, 45/32), (2083/4000, 1129/800), (2083/4000, 1133/800), (2083/4000, 1137/800), (2083/4000, 1141/800), (2083/4000, 229/160), (2083/4000, 1149/800), (2083/4000, 1153/800), (261/500, 141/100), (261/500, 283/200), (261/500, 71/50), (261/500, 57/40), (261/500, 143/100), (261/500, 287/200), (261/500, 36/25), (261/500, 289/200), (261/500, 29/20), (517/1000, 139/100)]

moreNmax6DisallowedPts :: [V 2 Rational]
moreNmax6DisallowedPts = toV <$> [(64/125, 67/50), (64/125, 269/200), (64/125, 27/20), (64/125, 271/200), (64/125, 34/25), (64/125, 273/200), (64/125, 137/100), (64/125, 69/50), (64/125, 11/8), (2053/4000, 1079/800), (2053/4000, 1083/800), (2053/4000, 1087/800), (2053/4000, 219/160), (2053/4000, 1091/800), (2053/4000, 1099/800), (2053/4000, 1103/800), (2053/4000, 1107/800), (2053/4000, 1111/800), (1029/2000, 543/400), (1029/2000, 109/80), (1029/2000, 547/400), (1029/2000, 549/400), (1029/2000, 551/400), (1029/2000, 553/400), (1029/2000, 111/80), (1029/2000, 557/400), (1029/2000, 559/400), (2063/4000, 1093/800), (2063/4000, 1097/800), (2063/4000, 1101/800), (2063/4000, 221/160), (2063/4000, 1109/800), (2063/4000, 1113/800), (2063/4000, 1117/800), (2063/4000, 1121/800), (517/1000, 11/8), (2063/4000, 45/32), (517/1000, 69/50), (517/1000, 277/200), (517/1000, 139/100), (517/1000, 279/200), (517/1000, 7/5), (517/1000, 141/100), (517/1000, 281/200), (517/1000, 283/200), (2073/4000, 1107/800), (2073/4000, 223/160), (2073/4000, 1111/800), (2073/4000, 1119/800), (2073/4000, 1123/800), (2073/4000, 1127/800), (2073/4000, 1131/800), (2073/4000, 227/160), (1039/2000, 557/400), (2073/4000, 1139/800), (1039/2000, 559/400), (1039/2000, 561/400), (1039/2000, 563/400), (1039/2000, 567/400), (1039/2000, 113/80), (1039/2000, 569/400), (1039/2000, 571/400), (1039/2000, 573/400), (2083/4000, 1121/800), (2083/4000, 45/32), (2083/4000, 1129/800), (2083/4000, 1133/800), (2083/4000, 1137/800), (2083/4000, 229/160), (2083/4000, 1141/800), (2083/4000, 1149/800), (2083/4000, 1153/800), (261/500, 141/100), (261/500, 283/200), (261/500, 71/50), (261/500, 57/40), (261/500, 143/100), (261/500, 287/200), (261/500, 289/200), (261/500, 36/25), (261/500, 29/20), (10351489/20000000, 22521/16000), (10370239/20000000, 11313/8000), (8288489/16000000, 18069/12800), (165806269/320000000, 361641/256000), (82881673/160000000, 90251/64000), (16594239/32000000, 18121/12800), (663562667/1280000000, 724229/512000), (663172043/1280000000, 1446117/1024000), (663169469/1280000000, 361339/256000), (1326918441/2560000000, 1447847/1024000), (2652635139/5120000000, 5784021/4096000), (331686297/640000000, 2894107/2048000), (1326383333/2560000000, 2892477/2048000), (10610937709/20480000000, 23138511/16384000), (5307180109/10240000000, 11578601/8192000), (1326498543/2560000000, 11568923/8192000)]

nmax6AllowedOPEincluded :: [[Rational]]
nmax6AllowedOPEincluded = [[33961528101/65536000000, 4631237303/3276800000, 4044206079579176/3807718649990341, 2498913440986/166804844592827, 3494265217405914/3170971085173315, 5228064468586358/3252780048166095, 1], [679059790739/1310720000000, 296061080461/209715200000, 3290165649985238/3090055104324701, 4917796084244/332254980535393, 1857039901029052/1680255676095777, 2105614892364520/1309744651488177, 1], [13582580281/26214400000, 18513552723/13107200000, 2791864024888482/2625329437432025, 39673294216742/2654391690324825, 3282721290982404/2974478890901825, 3173326700846724/1974035803444925, 1], [663212131/1280000000, 9254400719/6553600000, 156219291647645/146825115267346, 227961785471/15209419681059, 124536721556341/112757429656482, 33105505163514/20601030057931, 1], [33962696629/65536000000, 926044447/655360000, 3956515386877600/3723955330666019, 62121443933824/4074125774223481, 7649246580511132/6936308664274261, 9789854489526124/6094433882963511, 1]]

nmax6DisallowedOPEincluded :: [((Rational,Rational), (Rational,Rational,Rational,Rational,Rational))]
nmax6DisallowedOPEincluded = [((0.5180, 1.411), ((-38757737) / 88786972, (-82533) / 13425418, (-111357690) / 245817499, (-64848956) / 98255647, (-54187949) / 131974577)), ((0.5183, 1.414), ((-38757737) / 88786972, (-82533) / 13425418, (-111357690) / 245817499,  (-64848956) / 98255647, (-54187949) / 131974577))]

-- | Allowed points in the island computed in
-- 'TSigEps_OPEScan_island_nmax10_higher_spin'.
allowedPointsNmax10 :: [(V 2 Rational, V 5 Rational)]
allowedPointsNmax10 =
  [ ( toV (331616101607/640000000000, 180818073921/128000000000)
    , toV (-9363637830219671/21449302302676219, -62512279837051/10206830088654043, -1129762715287123/2493926178619129, -9445925830188796/14312025740703647, -3617294739013209/8810212630869343)
    )
  , ( toV (132645888561/256000000000, 361629426347/256000000000)
    , toV (-3483346697305979/7979143100027682, -77247124491619/12616451859333312, -2837010945268817/6262466311981820, -15062776786483300/22822734720941137, -6882932260595529/16764285259491440)
    )
  , ( toV (1326461943469/2560000000000, 723262827873/512000000000)
    , toV (-4115124118423352/9426392414580323, -43706806668215/7134340863922589, -9001962792093737/19871111664645786, -8173944070373566/12384958002860055, -2940562671385972/7162049794659003)
    )
  , ( toV (41451556551/80000000000, 144647495527/102400000000)
    , toV (-12778803244378267/29270903815173470, -81799252873343/13363784095467116, -5745395680647254/12681922339229465, -4427914902576580/6709213735503471, -3691374991359301/8991111444612049)
    )
  , ( toV (530587165833/1024000000000, 5786235747893/4096000000000)
    , toV (-3841009872378311/8798719106018892, -82190407778513/13414684269193507, -3535079396160301/7803706136230225, -3787969752673848/5739315471971131, -1452573928082787/3537820178429795)
    )
  , ( toV (5305834149029/10240000000000, 723253793849/512000000000)
    , toV (-4117817366572997/9432411046449060, -76283986846489/12454667522449713, -4327998023149807/9553518460540141, -4096049916280564/6206306398609935, -4156904500680601/10124699469435537)
    )
  , ( toV (1326471695783/2560000000000, 11572624296749/8192000000000)
    , toV (-1693131470934008/3878558776018503, -80109949749923/13074436853244326, -4787193546193457/10567968389645451, -6936532954633943/10509737287280675, -1379424068360977/3359611354860962)
    )
  , ( toV (10611647088243/20480000000000, 1157196725099/819200000000)
    , toV (-4676908327507940/10712984221619483, -53894800258133/8801535718899505, -3268818506888512/7215435362697207, -4133877669851494/6263654562054507, -5476378575281953/13338590519458810)
    )
  , ( toV (339573106485197/655360000000000, 370307045282619/262144000000000)
    , toV (-2958044190247547/6775830631230460, -36961576133157/6036737242434551, -2329562749207123/5142285835883454, -3907088840808791/5919937828636096, -3939843917890474/9596049041631281)
    )
  , ( toV (42446369911587/81920000000000, 23143512088263/16384000000000)
    , toV (-1196141758367939/2739845744423796, -52117223801212/8514670757860603, -9974625930857903/22017015990728263, -2985784418165869/4524108986038485, -17944645340202301/43708018615425585)
    )
  , ( toV (84893603051727/163840000000000, 5786106805283/4096000000000)
    , toV (-2697678317096593/6179480751222370, -57009942111199/9306442616675399, -2217818689378057/4895655612319037, -6805361718656109/10311332623346324, -4415851754548007/10755251254033246)
    )
  ]
